/*
 *	A Test of Lestrade: Creating Index
 *
 *	(c) 2004--2005 Martin Mares <mj@ucw.cz>
 *	(c) 2005 Tomas Valla <tom@ucw.cz>
 */

#include "ucw/lib.h"
#include "ucw/getopt.h"
#include "lestrade/lestrade.h"
#include "custom/custom.h"
#include "custom/debug.h"

#include <string.h>

static char *options = CF_SHORT_OPTS "d:i:";

int main(int argc, char **argv)
{
  uns n;
  byte idx[100] = "tmp/index";
  byte dir[100] = "../data";
  int opt;

  log_init(argv[0]);
  idx[sizeof(idx)-1] = dir[sizeof(dir)-1] = 0;
  while ((opt = cf_getopt(argc, argv, options, CF_NO_LONG_OPTS, NULL)) >= 0) 
    switch (opt)
      {
	case 'd':
	  strncpy(dir, optarg, sizeof(dir)-1);
	  break;
	case 'i':
	  strncpy(idx, optarg, sizeof(idx)-1);
	  break;
	default:
	  die("Usage: lt-indexer [-d dirname] [-i idxname]");
      }

  struct custom_index_hdr cih;
  bzero(&cih, sizeof(cih));
  strcpy(cih.comment, "Kerokero");

  lestrade_init(NULL);
  cf_set("Indexer.Verbose=1");
  n = lestrade_make_index(idx, test_card_enum, dir, &cih, sizeof(cih));

  msg(L_INFO, "Indexed %d cards", n);
  lestrade_cleanup();
  return 0;
}
