/*
 *	The Lestrade Search Library -- Customization for Indexing of Songs
 *
 *	(c) 2005 Martin Mares <mj@ucw.cz>
 */

#ifndef _LESTRADE_CUSTOM_H
#define _LESTRADE_CUSTOM_H

#define CUSTOM_INDEX_TYPE 'S'			/* A byte identifying our flavor of index format */
#define CUSTOM_INDEX_VERSION 1			/* Remember to increase after each change of custom parts of the index */

/* Custom data present in the header of the index */

#define DIR_NAME_LENGTH 128

struct custom_index_hdr {
  byte directory[DIR_NAME_LENGTH];
};

/* Data we remember in the index for each card */

#define CARD_NAME_LENGTH 128

struct card_attrs {
  byte name[CARD_NAME_LENGTH];			/* File name */
};

/* Custom part of struct lestrade_result */

struct custom_result {
};

/* Custom matching function */

struct lestrade_query;

static inline int				/* Returns card weight or <0 if card rejected */
custom_match_card(struct lestrade_query *Q UNUSED, struct card_attrs *ca UNUSED, struct custom_result *cr UNUSED)
{
  return 0;
}

/* This function is called when a lestrade_result is deleted, in order to free up memory associated with struct custom_result */

static inline void
custom_match_drop(struct lestrade_query *Q UNUSED, struct card_attrs *ca UNUSED, struct custom_result *cr UNUSED)
{
}

/* Word types */

enum word_type {
  WT_TEXT,
  WT_TITLE,
  WT_AUTHOR,
  WT_MAX
};

extern s8 word_type_weights[WT_MAX];		/* Must fit in 7 bits */

/* Dump functions used mostly by lidxdump */

struct fastbuf;
void dump_struct_card_attrs(struct fastbuf *out, struct card_attrs *c);
void dump_custom_index_hdr(struct fastbuf *out, struct custom_index_hdr *h, uns size);

#endif
